<template>
  <div class="logistics pagePadding">
    <div
      v-if="powers && powers.length > 0 && powers.some((item) => item == '001')"
    >
      <ex-table
        v-loading="loading"
        :table="table"
        :data="tableData"
        :columns="columns"
        :page="pageInfo"
        :size="size"
        @page-curr-change="handlePageChange"
        @page-size-change="handleSizeChange"
        @screen-reset="
          pageInfo.curr = 1;
          parmValue.page = 1;
          searchList();
        "
        @screen-submit="
          pageInfo.curr = 1;
          parmValue.page = 1;
          searchList();
        "
      >
        <template #table-header="{}">
          <el-row style="width: 100%">
            <el-col :span="4" style="width: 200px; padding: 0 0 0 10px">
              <el-select
                v-model="parmValue.status"
                filterable
                :size="'small'"
                clearable
                placeholder="状态"
                style="width: 100%"
                @change="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
              >
                <el-option
                  v-for="item in statusOptions"
                  :key="'status' + item.id"
                  :label="item.label"
                  :value="item.id"
                />
              </el-select>
            </el-col>
            <el-col :span="4" style="width: 220px; padding: 0 0 0 10px">
              <el-input
                v-model="parmValue.code"
                :maxlength="50"
                :size="'small'"
                @blur="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
                placeholder="物流编号"
              />
            </el-col>
            <el-col :span="4" style="width: 280px; padding: 0 0 0 10px">
              <el-input
                v-model="parmValue.express_name"
                :maxlength="50"
                :size="'small'"
                @blur="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
                placeholder="物流名称"
              />
            </el-col>

            <el-col :span="3" style="width: 66px; float: right">
              <el-button
                :size="'small'"
                type="primary"
                style="float: right; margin-left: 5px"
                @click="searchList"
              >
                刷新
              </el-button>
            </el-col>
            <el-col :span="4" style="width: 66px; float: right">
              <el-button
                type="warning"
                class="fr"
                :size="'small'"
                @click="restSearch"
              >
                重置
              </el-button>
            </el-col>
            <el-col :span="4" style="width: 54px; float: right">
              <el-button
                :size="'small'"
                type="primary"
                class="fr"
                icon="el-icon-search"
                @click="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
            /></el-col>
          </el-row>
        </template>
        <template #status="{ scope }">
          <el-tag
            :size="tablebtnSize"
            :type="scope.row.status == '0' ? 'warning' : ''"
            v-text="
              (statusOptions.find((item) => item.id == scope.row.status) || {})
                .label || '--'
            "
          ></el-tag>
        </template>
        <template #operation="{ scope }">
          <el-tooltip
            v-if="
              powers.some((item) => item == '004') && scope.row.status === '1'
            "
            effect="dark"
            content="禁用"
            placement="top"
          >
            <i
              class="el-icon-video-pause tb-icon"
              @click="statusConfirm(scope.row.id, scope.row.status)"
            ></i>
          </el-tooltip>
          <el-tooltip
            v-if="
              powers.some((item) => item == '004') && scope.row.status === '0'
            "
            effect="dark"
            content="启用"
            placement="top"
          >
            <i
              class="el-icon-video-play tb-icon"
              @click="statusConfirm(scope.row.id, scope.row.status)"
            ></i>
          </el-tooltip>
        </template>
      </ex-table>
    </div>
    <div v-else>
      <no-auth></no-auth>
    </div>
  </div>
</template>
   <script>
import mixinPage from "@/mixins/elPaginationHandle";
import ExTable from "@/components/ExTableNew.vue";
import resToken from "@/mixins/resToken";
import asyncRequest from "@/apis/service/system/logistics";
import { mapGetters } from "vuex";

export default {
  name: "logistics",
  mixins: [mixinPage, resToken],
  components: {
    ExTable,
  },
  computed: {
    ...mapGetters(["tablebtnSize", "searchSize", "size"]),
    powers() {
      let tran =
        this.$store.getters.btnList.find(
          (item) => item.menu_route == "logistics"
        ) || {};
      if (tran && tran.action && tran.action.length > 0) {
        return tran.action;
      } else {
        return [];
      }
    },
  },
  data() {
    return {
      // 状态
      statusOptions: [
        { id: "0", label: "禁用" },
        { id: "1", label: "启用" },
      ],
      loading: true,
      parmValue: {
        status: "", //物流属性
        code: "", //物流编号
        express_name: "",
        page: 1, // 页码
        size: 15, // 每页显示条数
      },
      tableData: [],
      // 表格 - 参数
      table: {
        stripe: true,
        border: true,
        _defaultHeader_: ["setcol"],
      },
      // 表格 - 分页
      pageInfo: {
        size: 15,
        curr: 1,
        total: 0,
      },
      // 表格 - 列参数
      columns: [
        {
          prop: "express_code",
          label: "物流编号",
        },
        {
          prop: "express_name",
          label: "物流名称",
        },

        {
          prop: "status",
          label: "状态",
          _slot_: "status",
          width: "100px",
        },
        {
          prop: "mobile",
          label: "电话",
        },

        {
          prop: "web_url",
          label: "官网",
        },
        {
          prop: "",
          label: "操作",
          fixed: "right",
          _noset_: true,
          _slot_: "operation",
          width: "50px",
        },
      ],
    };
  },
  mounted() {
    this.searchList();
  },

  methods: {
    restSearch() {
      this.parmValue = {
        status: "", //物流属性
        name: "", //物流名称
        page: 1, // 页码
        size: 15, // 每页显示条数
      };
      // 表格 - 分页
      this.pageInfo = {
        size: 15,
        curr: 1,
        total: 0,
      };
      this.searchList();
    },

    async searchList() {
      this.loading = true;
      const res = await asyncRequest.list(this.parmValue);
      if (res && res.code === 0 && res.data) {
        this.tableData = res.data.list;

        this.pageInfo.total = Number(res.data.count);
      } else if (res && res.code >= 100 && res.code <= 104) {
        await this.logout();
      } else {
        this.tableData = [];
        this.pageInfo.total = 0;
      }
      this.loading = false;
    },

    async statusConfirm(id, status) {
      let str = status === "1" ? "禁用" : "启用";
      await this.$confirm("确定要改为" + str + "?", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          this.loading = true;
          const model = {
            id: id,
            status: status === "1" ? "0" : "1",
          };
          const res = await asyncRequest.status(model);
          if (res && res.code === 0) {
            this.loading = false;
            this.$notify.success({
              title: "状态修改成功！",
              message: "",
            });
            await this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
  },
};
</script>
   <style lang="scss" scoped>
</style>
   